OpenJPEG 2.5.2

indexbox_manager.h
Go to the documentation of this file.
1/*
2 * $Id: indexbox_manager.h 897 2011-08-28 21:43:57Z Kaori.Hagihara@gmail.com $
3 *
4 * Copyright (c) 2002-2014, Universite catholique de Louvain (UCL), Belgium
5 * Copyright (c) 2002-2014, Professor Benoit Macq
6 * Copyright (c) 2003-2004, Yannick Verschueren
7 * Copyright (c) 2010-2011, Kaori Hagihara
8 * All rights reserved.
9 *
10 * Redistribution and use in source and binary forms, with or without
11 * modification, are permitted provided that the following conditions
12 * are met:
13 * 1. Redistributions of source code must retain the above copyright
14 * notice, this list of conditions and the following disclaimer.
15 * 2. Redistributions in binary form must reproduce the above copyright
16 * notice, this list of conditions and the following disclaimer in the
17 * documentation and/or other materials provided with the distribution.
18 *
19 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS `AS IS'
20 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
21 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
22 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
23 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
24 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
25 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
26 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
27 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
28 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
29 * POSSIBILITY OF SUCH DAMAGE.
30 */
31
36#ifndef INDEXBOX_MANAGER_H_
37# define INDEXBOX_MANAGER_H_
38
39#include "openjpeg.h"
40#include "j2k.h" /* needed to use jp2.h */
41#include "jp2.h"
42
43#define JPIP_CIDX 0x63696478 /* Codestream index */
44#define JPIP_CPTR 0x63707472 /* Codestream Finder Box */
45#define JPIP_MANF 0x6d616e66 /* Manifest Box */
46#define JPIP_FAIX 0x66616978 /* Fragment array Index box */
47#define JPIP_MHIX 0x6d686978 /* Main Header Index Table */
48#define JPIP_TPIX 0x74706978 /* Tile-part Index Table box */
49#define JPIP_THIX 0x74686978 /* Tile header Index Table box */
50#define JPIP_PPIX 0x70706978 /* Precinct Packet Index Table box */
51#define JPIP_PHIX 0x70686978 /* Packet Header index Table */
52#define JPIP_FIDX 0x66696478 /* File Index */
53#define JPIP_FPTR 0x66707472 /* File Finder */
54#define JPIP_PRXY 0x70727879 /* Proxy boxes */
55#define JPIP_IPTR 0x69707472 /* Index finder box */
56#define JPIP_PHLD 0x70686c64 /* Place holder */
57
58
59/*
60 * Write tile-part Index table box (superbox)
61 *
62 * @param[in] coff offset of j2k codestream
63 * @param[in] cstr_info codestream information
64 * @param[in] j2klen length of j2k codestream
65 * @param[in] cio file output handle
66 * @return length of tpix box
67 */
68 int opj_write_tpix(int coff, opj_codestream_info_t cstr_info, int j2klen,
69 opj_stream_private_t *cio,
70 opj_event_mgr_t * p_manager);
71
72
73/*
74 * Write tile header index table box (superbox)
75 *
76 * @param[in] coff offset of j2k codestream
77 * @param[in] cstr_info codestream information pointer
78 * @param[in] cio file output handle
79 * @return length of thix box
80 */
81 int opj_write_thix(int coff, opj_codestream_info_t cstr_info,
82 opj_stream_private_t *cio, opj_event_mgr_t * p_manager);
83
84
85/*
86 * Write precinct packet index table box (superbox)
87 *
88 * @param[in] coff offset of j2k codestream
89 * @param[in] cstr_info codestream information
90 * @param[in] EPHused true if EPH option used
91 * @param[in] j2klen length of j2k codestream
92 * @param[in] cio file output handle
93 * @return length of ppix box
94 */
95 int opj_write_ppix(int coff, opj_codestream_info_t cstr_info, OPJ_BOOL EPHused,
96 int j2klen, opj_stream_private_t *cio,
97 opj_event_mgr_t * p_manager);
98
99
100/*
101 * Write packet header index table box (superbox)
102 *
103 * @param[in] coff offset of j2k codestream
104 * @param[in] cstr_info codestream information
105 * @param[in] EPHused true if EPH option used
106 * @param[in] j2klen length of j2k codestream
107 * @param[in] cio file output handle
108 * @return length of ppix box
109 */
110 int opj_write_phix(int coff, opj_codestream_info_t cstr_info, OPJ_BOOL EPHused,
111 int j2klen, opj_stream_private_t *cio,
112 opj_event_mgr_t * p_manager);
113
114/*
115 * Write manifest box (box)
116 *
117 * @param[in] second number to be visited
118 * @param[in] v number of boxes
119 * @param[in] box box to be manifested
120 * @param[in] cio file output handle
121 */
122
123 void opj_write_manf(int second,
124 int v,
125 opj_jp2_box_t *box,
126 opj_stream_private_t *cio,
127 opj_event_mgr_t * p_manager);
128
129/*
130 * Write main header index table (box)
131 *
132 * @param[in] coff offset of j2k codestream
133 * @param[in] cstr_info codestream information
134 * @param[in] cio file output handle
135 * @return length of mainmhix box
136 */
137 int opj_write_mainmhix(int coff, opj_codestream_info_t cstr_info,
138 opj_stream_private_t *cio,
139 opj_event_mgr_t * p_manager);
140
141 int opj_write_phixfaix(int coff, int compno, opj_codestream_info_t cstr_info,
142 OPJ_BOOL EPHused, int j2klen, opj_stream_private_t *cio,
143 opj_event_mgr_t * p_manager);
144
145 int opj_write_ppixfaix(int coff, int compno, opj_codestream_info_t cstr_info,
146 OPJ_BOOL EPHused, int j2klen, opj_stream_private_t *cio,
147 opj_event_mgr_t * p_manager);
148
149 int opj_write_tilemhix(int coff, opj_codestream_info_t cstr_info, int tileno,
150 opj_stream_private_t *cio,
151 opj_event_mgr_t * p_manager);
152
153 int opj_write_tpixfaix(int coff, int compno, opj_codestream_info_t cstr_info,
154 int j2klen, opj_stream_private_t *cio,
155 opj_event_mgr_t * p_manager);
156
157#endif /* !INDEXBOX_MANAGER_H_ */
opj_write_tilemhix
int opj_write_tilemhix(int coff, opj_codestream_info_t cstr_info, int tileno, opj_stream_private_t *cio, opj_event_mgr_t *p_manager)
Definition thix_manager.c:97
opj_write_mainmhix
int opj_write_mainmhix(int coff, opj_codestream_info_t cstr_info, opj_stream_private_t *cio, opj_event_mgr_t *p_manager)
Definition cidx_manager.c:192
opj_write_phix
int opj_write_phix(int coff, opj_codestream_info_t cstr_info, OPJ_BOOL EPHused, int j2klen, opj_stream_private_t *cio, opj_event_mgr_t *p_manager)
Definition phix_manager.c:51
opj_write_tpixfaix
int opj_write_tpixfaix(int coff, int compno, opj_codestream_info_t cstr_info, int j2klen, opj_stream_private_t *cio, opj_event_mgr_t *p_manager)
Definition tpix_manager.c:86
opj_write_thix
int opj_write_thix(int coff, opj_codestream_info_t cstr_info, opj_stream_private_t *cio, opj_event_mgr_t *p_manager)
Definition thix_manager.c:40
opj_write_tpix
int opj_write_tpix(int coff, opj_codestream_info_t cstr_info, int j2klen, opj_stream_private_t *cio, opj_event_mgr_t *p_manager)
Definition tpix_manager.c:60
opj_write_phixfaix
int opj_write_phixfaix(int coff, int compno, opj_codestream_info_t cstr_info, OPJ_BOOL EPHused, int j2klen, opj_stream_private_t *cio, opj_event_mgr_t *p_manager)
Definition phix_manager.c:96
opj_write_ppixfaix
int opj_write_ppixfaix(int coff, int compno, opj_codestream_info_t cstr_info, OPJ_BOOL EPHused, int j2klen, opj_stream_private_t *cio, opj_event_mgr_t *p_manager)
Definition ppix_manager.c:104
opj_write_ppix
int opj_write_ppix(int coff, opj_codestream_info_t cstr_info, OPJ_BOOL EPHused, int j2klen, opj_stream_private_t *cio, opj_event_mgr_t *p_manager)
Definition ppix_manager.c:51
opj_write_manf
void opj_write_manf(int second, int v, opj_jp2_box_t *box, opj_stream_private_t *cio, opj_event_mgr_t *p_manager)
Definition cidx_manager.c:157
j2k.h
The JPEG-2000 Codestream Reader/Writer (J2K)
jp2.h
The JPEG-2000 file format Reader/Writer (JP2)
openjpeg.h
OPJ_BOOL
int OPJ_BOOL
Definition openjpeg.h:116
opj_codestream_info
Index structure of the codestream.
Definition openjpeg.h:853
opj_event_mgr
Message handler object used for.
Definition event.h:50
opj_jp2_box
JP2 Box.
Definition jp2.h:198
opj_stream_private
Byte input-output stream.
Definition cio.h:81